
clc;
clear
close all
imgDir=fullfile(pwd,'TrainData');
labelDir = fullfile(pwd,'TrainLabel');
imds=imageDatastore(imgDir);
classNames = ["nroi","roi"];
labelIDs   = [0 255];
pxds = pixelLabelDatastore(labelDir,classNames,labelIDs);
I = read(imds);
C = read(pxds);
% B=labeloverlay(I,C);
% figure,imshow(B)
imageSize=size(I);
numClasses=numel(classNames);
lgraph = segnetLayers(imageSize,numClasses,'vgg19');

numberOfLayers = numel(lgraph.Layers);
tbl = countEachLabel(pxds);

imageFreq = tbl.PixelCount ./ tbl.ImagePixelCount;
classWeights = median(imageFreq) ./ imageFreq;
pxLayer = pixelClassificationLayer('Name','labels','ClassNames',tbl.Name,'ClassWeights',classWeights);

lgraph = removeLayers(lgraph,'pixelLabels');
lgraph = addLayers(lgraph, pxLayer);
lgraph = connectLayers(lgraph,'softmax','labels');

opts = trainingOptions('sgdm', ...
    'InitialLearnRate',1e-1, ...
    'MaxEpochs',10, ...  
    'MiniBatchSize',16, ...
    'ExecutionEnvironment','cpu', ...
    'Plots','training-progress');
 %'VerboseFrequency',2, ...

datasource = pixelLabelImageSource(imds,pxds);
tic
[my_vgg19,info] = trainNetwork(datasource,lgraph,opts);
toc
save my_vgg19 my_vgg19


